import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.lang.*;
import java.util.*;
import java.io.*;
import java.util.*;
import gl4java.GLContext;
import gl4java.awt.GLCanvas;

import gl4java.utils.glut.*;

public class a5 extends Applet 
{
    jooglTransform tempTrans = new jooglTransform().setIdentity();
    jooglTransform permTrans = new jooglTransform().rotateX(-90);
    jooglTransform checkerTrans = new jooglTransform().setIdentity();

    // NEW VARIABLES FOR ASSIGNMENT 5
    // this is the root that will be passed
    // to the RayTraceWindow later.  (This code is in mouseReleased().)
    jooglRoot rootToTrace;
    
    /** 
     * The class variable that holds the canvas, so we can access it
     * from inner classes.
     */
    exampleCanvas canvas = null;
    
    jooglClock manClock = null;

    /**
     * void init()
     *
     * Initialise the applet.
     */
    public void init()
    {
        Dimension d = getSize();

        //We will use BorderLayout to layout the applet components
        setLayout(new BorderLayout());

        //Create our canvas and add it to the center of the applet
        canvas = new exampleCanvas(d.width, d.height);
        add("Center", canvas);
        
        /* retrieve the root object */
        jooglRoot root = new jooglRoot();

        manClock = new jooglManualClock();
        canvas.setClock(manClock);
        manClock.setTime(3200);
        
        /* create a camera */
        jooglCamera camera = 
            new jooglPerspectiveCamera(0.0, 2000.0, 4000.0, /* eye is really far back */
	 		   0.0, 1000.0, -150.0, /* center is at (0,0,-150) */
			   0.0, 6150.0, -2000.0, /* up is perpendicular to the view direction */
			   40.0, /* field of view in degree */ 
			   1.0, /* Z near */
			   10000.0);/* Z far */
        root.setCamera(camera);

        /* set the root to display the juggler */
        canvas.addRoot(root);

        /* create an ambient light and add it to the scene graph. */
        jooglAmbientLight lightAmb = new jooglAmbientLight(0.2, 0.2, 0.2);
        root.add(lightAmb);
        
        /* create a directional light to make it look good */
        jooglPositionalLight lightPos = new jooglPositionalLight(1, 1, 1, 1000.0, 2000.0, 200.0, 1.0, 0.0, 0.0);
        root.add(lightPos);

	jooglGroup group2 = new jooglGroup();
        group2.setTransform(tempTrans);
        root.add(group2);
        
        /* create a mocap group and add it to the root. */
        jooglGroup group = new jooglMocap("take2", 120);
	group.setTransform(permTrans);
	group2.add(group);
	
	/* make a checkerboard ground plane */
	jooglGroup checkerBoard = new jooglGroup();
	int squareSize = 200;
	boolean colored = true;
	for(int i = -(squareSize * 10); i < squareSize * 10; i+=squareSize) {
		colored = !colored;
		for(int j = -1000; j < squareSize * 20 - 1000; j+=squareSize){
			colored = !colored;
			float[] vertex = {i, 0, j,  
                                          i, 0, j+squareSize,  
                                          i+squareSize, 0, j+squareSize,  
                                          i+squareSize, 0, j};
			jooglPolygon poly = new jooglPolygon(vertex);
			if(colored)	poly.setMaterial(new jooglMaterial(0.8, 0.8, 0.05, 1.0, 
                                                                           1.0, 0.1, 2.0, 1.0));
			else		poly.setMaterial(new jooglMaterial(0.8, 0.05, 0.05, 1.0,
                                                                           1.0, 0.1, 2.0, 1.0));
                        checkerBoard.add(poly);
		}
        }
        checkerBoard.setTransform(checkerTrans);
	group2.add(checkerBoard);
 
        // the root we want to ray trace
        rootToTrace = root;
    }

    /** main, for when it is run from the command line. 
     *
     * Set up a window for the "applet" to run in.
     */
    public static void main( String args[] ) {
	a5 applet = new a5();

	Frame f = new Frame("CS4451A Joogl Example 1");
	f.addWindowListener( new WindowAdapter() {
		public void windowClosed(WindowEvent e)
		{
		    System.exit(0);
		}
		public void windowClosing(WindowEvent e)
		{
		    windowClosed(e);
		}
	    });

	f.setLayout(new BorderLayout());
	f.add("Center", applet);
	applet.setSize(300,600);
	applet.init();
	applet.start();
        f.pack();
	f.setVisible(true);

        //// FIRE OFF A RAY TRACER!
        
        // Create the RayTraceWindow that will display the results.
        RayTraceWindow traceWin = new RayTraceWindow(100, 200, applet.rootToTrace, applet.manClock);
    }

    /** jooglCanvas class for this application.     
     */
    private class exampleCanvas extends jooglCanvas implements MouseListener, MouseMotionListener
    {
        public exampleCanvas(int w, int h)
        {
            super(w, h);
        }
        /**
         * void preInit()
         *
         * Called just BEFORE the GL-Context is created.
         */
        public void preInit()
        {
            // initialize joogl
            super.preInit();
        }
        
        /*
	 * Methods required for the implementation of MouseMotionListener
	 */
        public void mouseMoved(MouseEvent evt)
        {
        }
    
        public void mouseDragged(MouseEvent evt)
        {
        }

        /*
	 * Methods required for the implementation of MouseListener
	 */
        public void mouseEntered(MouseEvent evt)
        {
        }
    
        public void mouseExited(MouseEvent evt)
        {
        }
    
        public void mousePressed(MouseEvent evt)
        {
        }
    
        public void mouseReleased(MouseEvent evt)
        {
        }
    
        public void mouseClicked(MouseEvent evt)
        {
	}
    }
}
